﻿using Infragistics.Controls.Maps;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamOrgChartDifferentItemTemplateCase
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            Department Main = new Department("Main");
            Department D1 = new Department("Dept1");
            SubDepartment D2 = new SubDepartment("Dept2");
            SubDepartment D3 = new SubDepartment("Dept3");
            SubDepartment D4 = new SubDepartment("Dept4");

            InitializeComponent();
            XamOrgChart1.DataContext = Main;

            Employee Emp1 = new Employee("Alex");
            Employee Emp2 = new Employee("Victoria");
            Employee Emp3 = new Employee("Ralph");
            Employee Emp4 = new Employee("Mary");

            Main.Departments.Add(D1);

            OrgChartNodeLayout DepartmentLayout = new OrgChartNodeLayout();
            OrgChartNodeLayout EmployeeLayout = new OrgChartNodeLayout();
            OrgChartNodeLayout SubDepartmentLayout = new OrgChartNodeLayout();

            DepartmentLayout.DisplayMemberPath = "DepartmentName";
            DepartmentLayout.TargetTypeName = "Department";
            DepartmentLayout.Key = "Departments";

            EmployeeLayout.DisplayMemberPath = "EmpName";
            EmployeeLayout.TargetTypeName = "Employee";
            EmployeeLayout.Key = "Employees";

            SubDepartmentLayout.DisplayMemberPath = "DepartmentName";
            SubDepartmentLayout.TargetTypeName = "Department";
            SubDepartmentLayout.Key = "SubDepartments";

            XamOrgChart1.GlobalNodeLayouts.Add(DepartmentLayout);

            //UNCOMMENT THESE IF YOU WANT TO SEE DEPARTMENTS INSTEAD.
            
            //D1.SubDepartments.Add(D2);
            //D1.SubDepartments.Add(D3);
            //D1.SubDepartments.Add(D4);

            D1.Employees.Add(Emp1);
            D1.Employees.Add(Emp2);
            D1.Employees.Add(Emp3);

            if (D1.SubDepartments.Count > 0)
            {
                XamOrgChart1.GlobalNodeLayouts.Add(SubDepartmentLayout);
            }
            else if (D1.Employees.Count > 0)
            {
                XamOrgChart1.GlobalNodeLayouts.Add(EmployeeLayout);
            }

        }
    }

    public class Department
    {
        public Department(string name)
        {
            this.DepartmentName = name;
            this.Departments = new ObservableCollection<Department>();
            this.Employees = new ObservableCollection<Employee>();
            this.SubDepartments = new ObservableCollection<SubDepartment>();
        }
        public string DepartmentName { get; set; }
        public ObservableCollection<Department> Departments { get; set; }
        public ObservableCollection<Employee> Employees { get; set; }
        public ObservableCollection<SubDepartment> SubDepartments { get; set; }
    }

    public class Employee
    {
        public Employee(string name)
        {
            this.EmpName = name;
        }

        public string EmpName { get; set; }
    }

    public class SubDepartment
    {
        public SubDepartment(string name)
        {
            this.SubName = name;
        }

        public string SubName { get; set; }
    }
}
